//*************************************************************************
//
//                        SDCARD Function
//
//*************************************************************************


#ifndef sd_card_H_
#define sd_card_H_


#include "globals.h"
#include "SDCARD/fat.h"
#include "SDCARD/file.h"
#include "SDCARD/mmc.h"
#include "SDCARD/mmc_config.h"
#include "display/displ_funktion.h"
#include "xram.h"


// Prototyps --------------------------------------------------------------
void init_SDCARD(void);
void read_sound(void);
void save_sound(void);
void create_Soundbank(void);
uint8_t load_wavefile(uint8_t osc_nr);
void freeBytes(void);
void getDir(char *directory, char *folder);
char *get_foldername(char *folder, uint8_t banknum);
void read_DirEntrys(uint8_t start_entry1, uint8_t last_entry1);
void getFileNumbers(void);
void getFileNames(char *prt);
void draw_SoundList(void);
void read_sample_dir(uint8_t curent_entry, uint8_t osc_nr);
void load_save_seq(void);
void save_wave_file(uint8_t osc_nr);
void delete_wavefile(uint8_t osc_nr);
void load_preset_list(uint8_t page_nr);
void set_preset_folder(void);
void load_preset_data(void);
void save_preset_data(void);
void set_presetname_folder(void);
void load_xwave(uint8_t osc_nr);
uint8_t read_par_value(uint8_t group_id, uint8_t par_id);
void write_par_value(uint8_t group_id, uint8_t par_id, uint8_t data);
void write_par_val32(uint8_t group_id, uint8_t par_id, uint32_t data);
uint32_t read_par_val32(uint8_t group_id, uint8_t par_id);
void delete_preset_data(void);
Bool load_user_waveforms(uint8_t osc_nr);
void Osc1_load_waveform(void);
void Osc2_load_waveform(void);
void read_dir_entrys(uint8_t current_entry);
Bool check_SABANK_exist(uint8_t SABANK_NR);
Bool check_PRBANK_exist(uint8_t PRBANK_NR);
void xram_test(void);
void read_samplename(uint8_t osc_nr);
void Save_osc_waveform(void);
void load_shape_bin(void);
void load_init_preset(void);

#endif /* sd_card_H_ */