//*************************************************************************
//
//                   neue Display-Funktion
//
//*************************************************************************


#ifndef displ_funktion_H_
#define displ_funktion_H_


//-------------------------------------------------------------------------
// includes
//
#include "globals.h"
#include "wavetable.h"
#include "keyquery.h"
#include "envelope.h"



//-------------------------------------------------------------------------
// funktion
//
extern const uint8_t txt_osc1[];
extern const uint8_t txt_osc2[];
extern const uint8_t txt_noise[];


void draw_loopA_line(void);
void draw_loopB_line(void);
void draw_zoom_wave(void);
void calc_cursorpos(void);
void draw_shifted_wave(void);
void draw_cursor(void);
//void save_background(void);
void restore_background(void);
void print_number8l(uint8_t number);
void draw_midi_icon(void);
void clear_midi_icon(void);
void init_Menu_Page(void);
void print_pagenr(void);
void clear_Page(void);
void select_mod_source(void);
void select_mod_destination(void);
void change_mod_depth(void);
void lcd_copyright(void);
void draw_adsr_line(void);
void draw_vcf_line(void);
void draw_sample_list(void);
void draw_menupage_soundprg(void);
void draw_menupage_seq(void);
void draw_menupage_scope(void);
void draw_menupage_system(void);
void draw_menupage_osc(uint8_t osc_nr);
void Osc_SubMenu_0_wave_mode(uint8_t osc_nr);
void Osc_SubMenu_1_wave_mode(uint8_t osc_nr);
void Osc_SubMenu0_sam(uint8_t osc_nr);
void Osc_SubMenu1_sam(uint8_t osc_nr);
void Osc_SubMenu2_sam(uint8_t osc_nr);
void Osc_SubMenu3_sam(uint8_t osc_nr);
void draw_scope_line(void);
void change_soundprg(void);
void change_osc1_submenu0_sam(void);
void change_osc1_submenu1_sam(void);
void change_osc1_submenu2_sam(void);
void change_osc1_submenu3_sam(void);
void change_osc2_submenu0_sam(void);
void change_osc2_submenu1_sam(void);
void change_osc2_submenu2_sam(void);
void change_osc2_submenu3_sam(void);
void change_env1(void);
void change_env2(void);
void change_filter2(void);
void change_seq(void);
void change_scope(void);
void change_system(void);
void draw_page_8(void);
void draw_page_9(void);
void draw_page_10(void);
void draw_page_11(void);
void draw_page_12(void);
void draw_page_13(void);
void draw_save_screen(void);
void draw_real_env(void);
void Clear_Env_Plot(void);





//void draw_char(char ascii, int x, int y, uint8_t font_hight, char VH, char VL);
void draw_char(unsigned char ascii, uint16_t x, uint8_t y, uint8_t font, uint8_t VH, uint8_t VL);








void draw_osc_rectangle(uint8_t wave_nr);
void draw_lfo_rectangle(uint8_t wave_nr);
void draw_lfo_rectangle(uint8_t wave_nr);

void checkmark_soundlist(void);
void draw_wave_sram(void);
void draw_cursor_wave(void);
void draw_seq_value_oct(void);
void draw_seq_load_save_query(void);
void change_modulationmatrix(void);
void draw_mod_submenu(void);
void draw_mod_source(void);
void draw_mod_destination(void);


void draw_sampling_curve(void);
void draw_wave_into_ram(void);
void timebase_value(void);
void trigger_value(void);
void set_scope_mode(void);
void change_osc1_save(void);
void draw_load_wavefile(uint8_t osc_nr);
void draw_delete_wavefile(uint8_t osc_nr);
void draw_save_presetfile(void);
void change_preset_save(void);
void get_preset_name(void);
void mini_scope(void);



void redraw_sample_file(void);
void draw_trigger_symbol(uint8_t y_pos);
void draw_rec_symbol(void);
void print_window_header(char VH, char VL, char text_str[], char sub_nrs[]);
void print_knop_text(char str1[], char str2[], char str3[], char str4[]);
void draw_waveform_flash(uint8_t wave_nr, uint16_t xpos, uint8_t ypos);
void draw_waveform_xram(uint8_t osc_nr, uint8_t wave_nrx, uint16_t xpos, uint8_t ypos);
void draw_osc_waveform_page(uint8_t osc_nr, uint8_t page_nr);
void set_sample_input(void);
void delay_grafic(void);

void draw_gray_frame(void);

void draw_puple_frame(void);
void draw_orange_frame(uint8_t par_nr_temp);

void print_window_header_test(char VH, char VL, char text[], char sub_nr[]);


#endif /* displ_funktion_H_ */