/*
 * envelope.h
 *
 * Created: 26.06.2016 11:07:00
 *  Author: Rolf Degen
 */ 


#ifndef ENVELOPE_H_
#define ENVELOPE_H_


#include "globals.h"
#include "wavetable.h"

void draw_menupage_env(uint8_t env_nr);
void Envelope_Task(void);
void envelope (uint8_t env_nr);
void change_env(uint8_t env_nr);

// new envelope from shruthi
void Init_Envelope(void);
uint8_t env_update(uint8_t env_nr);
void Trigger(uint8_t stage);
void Trigger_x1(uint8_t stage);
void Trigger_x2(uint8_t stage);

uint8_t Render(void);


enum
{
	ATTACK = 0, DECAY = 1, SUSTAIN = 2, RELEASE = 3, DEAD = 4, NUM_SEGMENTS,
};



struct Envelope
{
	// Current stage.
	uint8_t stage[2];
	
	// Phase and phase increment.
	uint16_t phase_increment[2];
	uint16_t phase[2];
			
	uint16_t value[2];
	uint16_t value_old[2];
	uint8_t value_8[2];
	
	uint8_t attack[2];
	uint8_t decay[2];
	uint8_t sustain[2];
	uint8_t release[2];
	
	uint8_t start_count;
	
	uint8_t env_nr;
	uint16_t release_16[2];
	
	uint16_t balance_x;
	
} Env;






#endif /* ENVELOPE_H_ */