/*
 * GUI.h
 *
 * Created: 23.07.2016 02:02:45
 *  Author: Rolf Degen
 */ 


#ifndef GUI_H_
#define GUI_H_




	

struct GraficUserInterface
{
	uint8_t entry_system_page;
	uint8_t entry_seq_page;
	
	
	uint8_t Led_tick;
	uint8_t Led1_time;
	uint8_t Led2_time;
	uint8_t Led3_time;
	uint8_t Led1_timer_value;
	uint8_t Led2_timer_value;
	uint8_t Led3_timer_value;
	
	// Oscillators
	uint8_t osc_par_nr[2];
	uint8_t osc_submenu[2];
	uint8_t osc_old_page_nr[2];
	uint8_t wave_nr[2];
	uint8_t start_entry[2];
	uint8_t last_entry[2];
	uint8_t current_entry[2];
	uint8_t old_selEntry[2];
	uint8_t osc_old_selEntry[2];
	uint8_t Osc_current_entry[2];
	uint8_t Osc_start_entry[2];
	uint8_t Osc_last_entry[2];
	uint8_t redraw_flag[2];
	char file_name1[13];
	char file_name2[13];
	uint8_t file_not_found;
	
	// LFO
	uint8_t lfo_submenu[3];
	
	// sampling
	uint8_t sam_submenu;
	uint8_t Sam_current_entry;
	uint8_t Sam_old_entry;
	uint8_t Sam_start_entry;
	uint8_t Sam_last_entry;
	uint8_t Sam_rec_mode;
	uint8_t Sam_monitor_flag;
	uint8_t Sam_rec_key_flag;
	uint8_t Sam_rec_flag;
	uint8_t Sam_threshold_flag;
	uint8_t time1;			// Led-Bar
	uint8_t time1_flag;		// Led-Bar
	uint8_t rec_led_flag;   // Rec Led on/off
	
	// Cursor edit sampling
	uint8_t CurA_value;
	uint8_t CurB_value;
	uint8_t CurA_old_value;
	uint8_t CurB_old_value;
	__uint24 CurA_addr;
	__uint24 CurB_addr;
	__uint24 addr_offset;
	uint8_t Zoom_value;
	__uint24 block_size;
	uint8_t redraw_flag2;
	uint8_t cut_flag;
	uint8_t del_flag;
	uint8_t sample_edit_function;
	uint8_t old_loop_function;
	
	// Menu
	uint8_t old_enc3_value;
	uint8_t max_nr_pages;
	uint8_t real_env_time;
	uint8_t real_env_flag;
	uint8_t file_not_found_flag;
	
	// Patch
	uint8_t last_patch;
	
	// system
	uint8_t filtertyp;
	
}Gui;


void write_com_data(uint8_t addr, uint16_t num);
void write_com(uint8_t data);
void write_data(uint16_t data);
void set_Cursor(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2);
void rectangle(uint16_t x, uint8_t y, uint8_t height, uint16_t width, uint8_t VH, uint8_t VL);
void fillrectangle(uint16_t x1, uint8_t y1, uint16_t x2, uint8_t y2, uint8_t VH, uint8_t VL);
void circle(uint16_t x, uint8_t y, uint8_t radius, uint8_t VH, uint8_t VL);
void fill_circle(uint16_t x, uint8_t y, uint8_t radius, uint8_t VH, uint8_t VL);
void hline(uint16_t x, uint8_t y, uint16_t l, uint8_t VH, uint8_t VL);
void vline(uint16_t x, uint8_t y, uint8_t l, uint8_t VH, uint8_t VL);
void draw_line(uint16_t x0, uint8_t y0, uint16_t x1, uint8_t y1, uint8_t VH, uint8_t VL);
void draw_width_line(uint16_t x0, uint8_t y0, uint16_t x1, uint8_t y1, uint8_t VH, uint8_t VL);
void pixel(uint16_t x1, uint16_t y1, uint8_t VH, uint8_t VL);
void Paint(uint8_t VH, uint8_t VL);
void clear_WindowArea(uint8_t VH, uint8_t VL);
void print_string(char *str, uint16_t x, uint8_t y, uint8_t font, uint8_t VH, uint8_t VL);
void print_string_right(char *str, uint16_t x, uint8_t y, uint8_t font, uint8_t VH, uint8_t VL);
void draw_knop(void);
void draw_knop_bitmap(uint16_t xpos, uint8_t ypos);
void draw_sdcard_symbol(uint16_t xpos, uint8_t ypos);
void draw_sine_symbol(uint16_t xpos, uint8_t ypos, uint8_t VH, uint8_t VL);
void draw_wavefile_symbol(uint16_t xpos, uint8_t ypos, uint8_t VH, uint8_t VL);
void draw_encoder_StrPos(uint8_t enc_num, char *string, uint8_t point_position);
void draw_encoder_position(uint8_t enc_num, uint16_t value);
void draw_encoder_position_signed(uint8_t enc_num, int8_t value, uint8_t max_value);
void draw_encoder_plusminus(uint8_t enc_num, uint8_t current_value, uint8_t max_value);
void draw_plusminus_value(uint16_t xpos, uint8_t ypos, uint8_t current_value, uint8_t max_value);
void draw_range_value(uint16_t xpos, uint8_t ypos, uint8_t current_value, uint8_t max_value);
void draw_10digit_with(uint32_t value, uint16_t x_pos, uint8_t y_pos, uint8_t font, uint8_t VH, uint8_t VL);
void draw_6digit_with(__uint24 value, uint16_t x_pos, uint8_t y_pos, uint8_t font, uint8_t VH, uint8_t VL);
void draw_5digit_with(uint32_t value, uint16_t x_pos, uint8_t y_pos, uint8_t font, uint8_t VH, uint8_t VL);
void draw_4digit_without(uint16_t value, uint16_t x_pos, uint8_t y_pos, uint8_t font, uint8_t VH, uint8_t VL);
void draw_3digit_with(uint16_t value, uint16_t x_pos, uint8_t y_pos, uint8_t font, uint8_t VH, uint8_t VL);
void draw_3digit_without(uint16_t value, uint16_t x_pos, uint8_t y_pos, uint8_t font, uint8_t VH, uint8_t VL);


void draw_symbol(uint8_t index, uint16_t x, uint8_t y, uint8_t VH, uint8_t VL);
void draw_startscreen(void);
void draw_menupage_soundprg(void);
void draw_menupage_osc(uint8_t osc_nr);
void draw_menupage_osc_off(uint8_t osc_nr);
void draw_menupage_lfo(uint8_t lfo_nr);
void draw_menupage_Fx(void);
void draw_menupage_seq(void);
void draw_menupage_scope(void);
void draw_menupage_sampling(void);
void draw_menupage_modulationmatrix(void);
void draw_menupage_system(void);
void draw_sample (void);
void Osc_SubMenu_0(uint8_t osc_nr);
void Osc_SubMenu_1(uint8_t osc_nr);
void Osc_SubMenu_2(uint8_t osc_nr);

void change_osc(uint8_t osc_nr);
void change_osc_submenu0(uint8_t osc_nr);
void change_osc_submenu1(uint8_t osc_nr);
void change_osc_submenu2(uint8_t osc_nr);
void change_lfo(uint8_t lfo_nr);
void change_Fx(void);
void change_seq(void);
void change_scope(void);
void change_sampling(void);
void change_modulationmatrix(void);
void change_sample_save(uint8_t osc_nr);

void draw_menupage_env(uint8_t env_nr);
void draw_real_env(void);
void redraw_sample_curve (uint8_t osc_nr);
void LED_Task(void);
void print_free_ram (void);
void redraw_organge_frame (void);
void print_OnOff_osc_submenu1 (uint8_t osc_nr, uint8_t status, uint8_t row, uint8_t col);
void print_osc_mode_value(uint8_t osc_mode);
void print_osc_op_value(uint8_t osc_op);
void print_osc_select_pos(uint8_t select_pos);
void Sample_manager_load_sample(void);
void draw_cursor_A (void);
void draw_cursor_B (void);
void print_user_waveform(uint8_t osc_nr);
void draw_shape_waveform(uint8_t osc_nr, uint8_t shape_nr);
void print_osc_wave_mode(uint8_t xx);
void draw_mod_names(uint8_t slot_column, uint8_t index, uint8_t slot_nr);
void print_file_not_found (uint16_t wait_time, uint8_t xpos, uint8_t ypos);
void draw_sample_window_header (void);
void delay_grafic(void);
void cut_sample(void);
void draw_zoom_sample (uint8_t zoom_level);
__uint24 calc_cursor_addr(uint8_t CurX_value, uint8_t osc_nr);
void sample_editor_func(void);
void reverse_sample(void);
void silence_sample(void);
void draw_save_file(void);
void set_encoder_val(uint8_t val2, uint8_t val3, uint8_t val4, uint8_t val5);
void set_encoder_max(uint16_t max2, uint16_t max3, uint16_t max4, uint16_t max5);
void set_encoder_dyn(uint8_t dyn2, uint8_t dyn3, uint8_t dyn4, uint8_t dyn5);
void draw_lfo_waveform(void);
void draw_seq_dir(void);
void draw_seq_note_div(void);
void draw_sequencer_notes(void);
void draw_sequencer_rectangle(void);
void draw_midi_note(uint8_t step_note, uint16_t x_pos, uint8_t y_pos, uint8_t font, char VH, char VL);
void save_enc3_values(uint8_t value);
void set_arp_enc_values(void);
void print_info_box (char *string, uint8_t xpos, uint8_t ypos, uint16_t wait_time);



#endif /* GUI_H_ */