//*************************************************************************
//
//                   define global variable
//
//*************************************************************************


#ifndef init_global_H_
#define init_global_H_


//############################# n e w #####################################

//-------------------------------------------------------------------------
// Oscillator 1
//-------------------------------------------------------------------------

uint8_t Osc1_wave_mode;
uint8_t Osc1_op;

//-------------------------------------------------------------------------
// Oscillator 2
//-------------------------------------------------------------------------
uint8_t Osc2_wave_mode;
uint8_t Osc2_op;



//-------------------------------------------------------------------------
// LCD Menu
//-------------------------------------------------------------------------
//uint8_t inverse = 0;				// invert pixel
uint16_t test_timer = 0;			// Timer for Testfunktion
uint8_t test_timer_flag = 0;		// Flag for Timer
uint16_t time_flag1_count = 0;		// Timer-Counter for Testfunktion
uint8_t time_flag1 = 0;				// Timer-Flag for Testfunktion
uint8_t old_x = 0;					// old xpos in LCD-Routine
uint8_t page_nr = 0;				// LCD-Menu Page-Nr.
uint8_t old_page_nr = 0;
uint8_t last_pagenr = 14;			// last page nummer (count from 0)
uint8_t vca_submenu = 0;				// Unterseite im VCA-Menu
uint8_t osc1_upage = 0;				// Unterseite im Osc1-Men
uint8_t osc2_upage = 0;				// Unterseite im Osc2-Men
uint8_t vcf_env_upage = 0;			// Unterseite im VCF-Env Men
uint8_t enc2_upage = 0;
uint8_t osc1_submenu = 0;
uint8_t osc2_submenu = 0;
uint8_t lfo1_submenu = 0;
uint8_t lfo2_submenu = 0;
uint8_t lfo3_submenu = 0;
uint8_t vcf1_submenu = 0;
uint8_t env1_submenu = 0;
uint8_t env2_submenu = 0;
uint8_t env3_submenu = 0;
uint8_t env4_submenu = 0;
uint8_t seq_submenu = 0;
uint8_t mod_submenu = 0;
uint8_t submenu_nr = 0;
uint8_t menu_selection = 0;			// 1 = Menu selection disabled
uint8_t char_name = 0;				// char for Sound Name
uint8_t char_pos = 0;				// char position in the namen
uint8_t lcd_env_point = 0;
uint8_t env_x1 = 132;
uint8_t env_x2;
uint8_t clr_env_curve_flag = 0;		// 1 = clr real env curve
uint8_t cursor_pos_old = 0;
uint8_t cursor_pos_new = 0;
uint8_t cursor_loopA = 0;
uint8_t cursor_loopB = 0;
uint8_t zoom_level = 0;
uint8_t cursorbuffer[8];			// Buffer to restore Cursor Background
uint32_t cursor_time_code = 0;
uint32_t cursor_wave_address = 0;
uint32_t screen_startaddr = 0;
uint32_t screen_endaddr = 0;
uint32_t loop_startaddr = 0;
uint32_t loop_endaddr = 0;
uint8_t old_selEntry = 0;
uint16_t new_cursor_pos = 0;
uint8_t osc1_old_selEntry = 0;
uint8_t osc2_old_selEntry = 0;
uint16_t osc1_old_cursor_pos = 0;
uint16_t osc2_old_cursor_pos = 0;
uint32_t cursor_addr_offset = 0;
char preset_name[];
uint8_t colorH;
uint8_t colorL;

uint8_t Osc1_current_entry;
uint8_t Osc1_start_entry;
uint8_t Osc1_last_entry;
uint8_t Osc2_current_entry;
uint8_t Osc2_start_entry;
uint8_t Osc2_last_entry;
uint8_t Sound_current_entry;
uint8_t Sound_start_entry;
uint8_t Sound_last_entry;



//*************************************************************************
// Oscillator
//*************************************************************************
//uint8_t SBufChA[256];			// Sample Buffer
volatile uint8_t SBufChA_rdpointer = 0;
volatile uint8_t SBufChA_wrpointer = 0;
uint8_t sample_indexChA = 0;
volatile uint8_t sample_adr = 0;
uint16_t wave_adr = 0;
uint8_t wave_frq = 20;
uint32_t wave_len = 0;
uint8_t wave_nr1 = 0;
uint8_t wave_nr2 = 0;
uint8_t wavebank1 = 0;
uint8_t wavebank2 = 0;
uint8_t sound_nr = 0;
uint8_t bank_nr = 0;
uint8_t oktave_value1 = 0;
uint8_t oktave_value2 = 0;
uint8_t transpose_value1 = 12;
uint8_t transpose_value2 = 12;
uint8_t detune_value1 = 64;
uint8_t detune_value2 = 64;
int8_t pitch_oct1 = 0;
int8_t pitch_oct2 = 0;
uint8_t osc1_mode = 0;
uint8_t osc2_mode = 0;
uint8_t osc_mode = 0;
volatile uint64_t phaccu1 = 0;
volatile uint64_t phaccu2 = 0;
uint32_t phaccu_stepsize1 = 0;
uint32_t phaccu_stepsize2 = 0;
volatile uint16_t wavetable_dco1;			// Wavetable fr DCO1
volatile uint16_t wavetable_dco2;			// Wavetable fr DCO2
volatile uint8_t old_wave = 0;
volatile uint8_t new_wave = 0;
volatile uint8_t pwm1_level = 0;
volatile uint8_t pwm2_level = 0;
int8_t pitch_semi1 = 0;						// Transpose Value Osc1
int8_t pitch_semi2 = 0;						// Transpose Value Osc2
int8_t pitch_fine1 = 0;						// Detune Value Osc1
int8_t pitch_fine2 = 0;						// Detune Value Osc2
volatile uint8_t osc1_value = 127;
volatile uint8_t osc2_value = 127;
uint8_t temp_osc1_value;
uint8_t temp_osc2_value;
volatile uint8_t osc1_volume = 127;
volatile uint8_t osc1_pan = 0;
volatile uint8_t osc2_volume = 127;
volatile uint8_t osc2_pan = 0;
volatile int8_t osc1_balance = 0;
volatile int8_t osc2_balance = 0;
volatile uint8_t Bitcrush = 0xFF;		// Bit reduction
uint8_t Bitcrush_Bits = 8;
int32_t osc1_stepsize = 0;
int32_t osc2_stepsize = 0;

uint16_t wave_shrink = 0;
uint8_t cursor1_xpos = 0;
uint8_t cursor2_xpos = 127;
uint32_t wave_offset = 0;
uint16_t addoffset = 0;
uint8_t enc_waveoffset = 0;
uint8_t enc_addoffset = 0;
uint32_t wave_adr1 = 0;
uint32_t wave_adr2 = 0;
volatile uint32_t wave_adr3 = 0;
volatile uint32_t wave_adr4 = 0;
uint8_t sel_sample = 0;
volatile uint8_t loop_flag = 0;
volatile uint8_t loop_end_flag1 = 0;
volatile uint8_t loop_end_flag2 = 0;
uint8_t bandlim_octave_osc1 = 0;
uint8_t bandlim_octave_osc2 = 0;
int8_t midi_trans = 0;
uint8_t Osc1_ReTrig = 1;

// for use in assembly code without struct
uint8_t Osci_osc_mix;
uint8_t Osci_noise_mix;
uint8_t Osci_operator;
uint8_t Osci_operator2;
uint8_t Osci_bitcrush;
uint8_t Osci_puls;
uint8_t Osci_puls2;
uint8_t Osci_pwm_value;
uint8_t Osci_pwm_value2;
uint16_t Osci_sin_wav;	// Addr sin_wav Table
uint16_t Osci_fm_ratio; // Addr fm_ratio Table
uint32_t Osci_phase2;
uint8_t wavefile_flag = 0;
uint8_t Osc1_wavefile_flag;
uint8_t Osc2_wavefile_flag;
uint8_t Osc1_wave_mode;
uint8_t Osc2_wave_mode;

//*************************************************************************
// Oscillator 1
//*************************************************************************
uint8_t Osc1_operator;

//-------------------------------------------------------------------------
// sampling
//-------------------------------------------------------------------------
volatile uint8_t sampling_flag = 0;
__uint24 sampling_wr_addr = 0;
__uint24 sampling_rd_addr = 0;
uint8_t Sampling_rec_mode = 2;
uint8_t Sampling_recording;
uint8_t Sampling_threslev;
uint8_t Sampling_thresflag;
volatile uint8_t Sampling_recflag;
uint8_t redraw_sample;
volatile uint8_t Sampling_monitor_flag;

//-------------------------------------------------------------------------
// ADC Input
//-------------------------------------------------------------------------
uint8_t poti1_value;
uint8_t poti2_value;
uint8_t poti_mux;

//-------------------------------------------------------------------------
// Amplifier (VCA)
//
uint8_t vca1_value = 127;
uint8_t vca2_value = 127;
uint16_t vca1_out;
uint16_t vca2_out;
volatile uint8_t pan_mix = 64;

//*************************************************************************
// Modulation Matrix
//*************************************************************************
uint8_t lfo1_depth_vca;
uint8_t lfo2_depth_vca;
uint8_t env1_depth_vca;
uint8_t env2_depth_vca;
uint8_t lfo1_depth_vcf;
uint8_t lfo2_depth_vcf;
uint8_t env1_depth_vcf;
uint8_t env2_depth_vcf;
uint8_t lfo1_depth_osc1;
uint8_t lfo2_depth_osc1;
uint8_t env1_depth_osc1;
uint8_t env2_depth_osc1;
uint8_t lfo1_depth_osc2;
uint8_t lfo2_depth_osc2;
uint8_t env1_depth_osc2;
uint8_t env2_depth_osc2;
uint8_t lfo1_depth_fx;
uint8_t lfo2_depth_fx;
uint8_t env1_depth_fx;
uint8_t env2_depth_fx;

//----------------------
uint8_t slot_array[12][3];
uint16_t source_addr[12];
uint16_t destination_addr[12];
uint16_t dummy_addr = 0;
uint8_t slot_nr;
uint8_t source_nr;
uint8_t destination_nr;
uint8_t mod_amount;
uint16_t VCA_gain;
uint16_t VCF_cutoff;
uint16_t VCF_resonanc;
uint16_t Fx_gain;

uint32_t xxxx;




//-------------------------------------------------------------------------
// Midi
//
uint8_t midibuf[0x80];					// Midi Receive Buffer
uint8_t midibuf_wr_pointer=0;			// Write-Pointer for Midi-Buffer
uint8_t midibuf_rd_pointer=0;			// Read-Pointer for Midi-Biffer
uint8_t midi_byte;
uint8_t midi_statusbyte = 0;
uint8_t midi_data1 = 0;
uint8_t midi_data2 = 0;
uint8_t midi_datasize = 0;						// Midi Datenbyte Lnge
uint8_t midi_datapointer = 0;
uint8_t midi_note = 0;
uint8_t last_midi_note = 0;
uint8_t first_midi_note = 0;
uint8_t velocity = 0;
uint8_t velo_temp = 0;
uint8_t NoteOn_icon = 0;
uint8_t midi_icon_set = 0;
uint8_t midi_receive_chanal = 0;
uint16_t midi_pitchbend = 8192;
uint8_t led_timer = 0;
uint8_t ctrl_data0 = 0;
uint8_t ctrl_data1 = 1;
uint8_t prgchange_nr = 0;
uint8_t arpeggio_flag = 0;
uint16_t arpeggio_timer0 = 250;
uint16_t arpeggio_timer1 = 50;
uint8_t arpeggio_step = 0;
uint8_t midictrl_data1 = 0;
uint8_t midictrl_data2 = 0;
uint8_t midictrl_data3 = 0;
uint8_t midictrl_data4 = 0;
uint8_t midictrl_data5 = 0;
uint8_t midictrl_data6 = 0;
uint8_t midictrl_data7 = 0;
uint8_t midictrl_data8 = 0;
uint8_t midictrl_flag = 0;		// ctrl_flag=1 Midi Ctrl-Data received

uint8_t midi_sync_flag;
uint8_t midi_gate_flag;

uint8_t midi_data[2];
uint8_t NoteStack_pool[10];
uint8_t VeloStack_pool[10];
uint8_t NoteStack_ptr = 0;
uint8_t NoteStack_size = 10;
uint8_t data_size;
uint8_t expected_data_size = 50;
uint8_t note_count = 0;
uint8_t midi_velocity;
uint8_t midi_channel;
uint8_t midi_note_trigger = 0;
uint8_t midi_note_gate = 0;


	
//-------------------------------------------------------------------------
// Delay Effect
//-------------------------------------------------------------------------
uint8_t delay_volume = 0;
uint8_t delay_volume1 = 0;
uint8_t delay_volume2 = 0;
uint8_t delay_panorama = 0;
uint8_t delay_panorama1 = 0;
uint8_t delay_time = 0;
uint8_t delay_time1 = 0;
uint8_t delay_feedback = 0;

//-------------------------------------------------------------------------
// SDCARD
//
uint8_t SDCARD_status = 0;
uint8_t selected_file = 0;
char filename_buffer[84];			// 7 x 12 Character per Filename
uint8_t file_len_h;
uint8_t file_len_l;
uint8_t file_info;
uint8_t sd_disable = 0;
__uint24 file_lenght = 0;
char file_name[12];
uint8_t save_flag = 0;
uint8_t load_flag = 0;
uint8_t delete_flag = 0;
uint8_t cancle_flag = 0;
uint8_t load_wavefile_flag = 0;
uint16_t seek_pointer16;

uint8_t file_current_entry;
uint8_t file_last_entry;
uint8_t file_temp_entry;

//*************************************************************************
// Sound
//*************************************************************************
char soundname_x[17];				// Buffer for Sound Name
uint16_t sdata_len;
uint8_t sound = 0;
uint8_t sel_sound = 0;
uint8_t sound_bank = 0;
uint8_t sel_sound_bank = 0;
uint8_t wavebank = 0;
uint8_t samplebank = 0;
uint8_t sample_bank_nr;
char sample_file_name[13];
char sample_name[13];
uint8_t file_numbers;
uint32_t quantization_error; // when 0 noise in sound
__int24 quantization_error2;
uint32_t quant_error32 = 0;
uint32_t quant_error24 = 0;
uint16_t quant_error16 = 0;
uint8_t test_value = 0;

uint8_t preset_nr;
uint8_t current_preset;
uint8_t select_preset;
uint8_t current_presetbank;
uint8_t select_presetbank;


//*************************************************************************
// SEQUENZER
//*************************************************************************
uint8_t seq_run;
uint8_t seq_clock_flag = 0;
uint16_t seq_speed = 30;
uint16_t seq_speed_temp = 30;
uint16_t seq_pulswidth;

uint8_t seq_note;
int8_t step_nr;
uint8_t dir_flag;
uint8_t step_note[16];
uint8_t step_hold[16];
uint8_t step_function[16];
uint8_t step_mod[16];
uint8_t selected_step_nr;
uint8_t seq_oct = 2;
uint8_t seq_dir;
uint8_t seq_func;
uint8_t seq_shuffle;
uint8_t seq_rec;
uint8_t seq_load;
uint8_t seq_nr;
uint8_t seq_load_save_flag;

//-------------------------------------------------------------------------
// Global Parameter
//-------------------------------------------------------------------------
uint8_t global_select;
uint8_t global_value;

//-------------------------------------------------------------------------
// Sonstiges
uint8_t soft_timer0 = 0;
uint16_t soft_timer1 = 0;
uint8_t soft_timer2 = 0;
uint8_t soft_timer3 = 0;
uint8_t soft_timer4 = 0;
uint16_t soft_timer11 = 0;
uint8_t soft_timer11_flag = 0;

volatile uint8_t soft_timer0_flag = 0;
uint8_t timer0_flag = 0;		// is setting in timer0 interrupt
uint8_t timer3_flag = 0;
uint8_t soft_timer1_flag = 0;
uint8_t soft_timer2_flag = 0;
uint8_t soft_timer3_flag = 0;
uint8_t soft_timer4_flag = 0;
uint8_t led0_timer;
uint8_t led1_timer;
uint8_t led2_timer;
uint8_t led3_timer;
uint8_t led4_timer;
uint8_t led5_timer;
uint8_t led6_timer;
uint8_t led7_timer;

// timer variable ( 10 ms intervall)
volatile uint16_t TimingDelay;



volatile uint16_t stackpointer;

#endif /* init_global_H_ */