/*
 * keyquery.h
 *
 * Created: 27.06.2016 20:01:08
 *  Author: rolfd
 */ 


#ifndef KEYQUERY_H_
#define KEYQUERY_H_


// values for enc-dynamic
#define ENCODER_ACCEL_TOP    128
#define ENCODER_ACCEL_INC	 4
#define ENCODER_ACCEL_DEC    1

#define Key_SUB		1
#define Key_OSC		2
#define Key_VCF		3
#define Key_ENV		4
#define Key_LFO		5
#define Key_MOD		6
#define Key_LOAD	7
#define Key_SAVE	8
#define Key_DEL		9
#define Key_SEQ		10
#define Key_REC		11
#define Key_ESC		12


struct Encoder
{
	uint8_t Buffer[0x22];
	uint8_t Buf_wrpointer;
	uint8_t Buf_rdpointer;
	uint8_t Buf_counter;
	uint8_t value[5];
	uint8_t value_[5];
	uint8_t value_old[5];
	uint8_t maxval[5];
	uint8_t status[5];
	uint8_t status_[5];
	uint8_t enabled[5];
	uint8_t dynamic[5];
	uint8_t dynamic_;
	int16_t delta[5];
	uint8_t Accel[5];
	int8_t last[5];
	int8_t last_[5];	
} Enc;

struct KEYS
{
	uint8_t ReadShiftReg_Flag;		// Flag is set in Timer3 Interrupt every >1msec
	uint8_t KeyQueryFlag;			// Flag is set in Timer1 Envelope Interrupt evry 1msec
	uint8_t KEY_DATA1;				// read serial key data from Front Pannel 74HC165 IC3-5
	uint8_t KEY_DATA2;				//
	uint8_t KEY_DATA3;				//
	uint8_t key_nr;
	uint8_t key_nr_old;
	uint8_t key_debounce_time;		// set value for debounce time
	uint8_t query_flag;
	uint8_t key1_enable;
	uint8_t key2_enable;
	uint8_t key3_enable;
	uint8_t key4_enable;
	uint8_t key5_enable;
	uint8_t key6_enable;
	uint8_t key7_enable;
	uint8_t key8_enable;
	uint8_t key9_enable;
	uint8_t key10_enable;
	uint8_t key11_enable;
	uint8_t key12_enable;
	uint8_t key13_enable;
}Key;


void read_74hc165(void);
void read_enc_status(void);
void get_encoder(void);
void update_values_menupage(void);
void get_keys(void);
void draw_load_screen(void);
void key_press(void);
void key_less(uint8_t key_number);
void key_function(void);
void sdcard_status(void);
void enable_encoder(uint8_t enc1, uint8_t enc2, uint8_t enc3, uint8_t enc4, uint8_t enc5);
void enable_key(uint8_t key1,uint8_t key2,uint8_t key3,uint8_t key4,uint8_t key5,uint8_t key6,
uint8_t key7,uint8_t key8,uint8_t key9,uint8_t key10,uint8_t key11,uint8_t key12,uint8_t key13);
void init_keys(void);
void wr_EncBuffer(uint8_t enc_id, uint8_t enc_value);
uint8_t rd_EncBuffer(void);
void encoder_query (void);
void init_sample_recording(void);
void sample_edit_cut(uint8_t osc_nr);
void sample_edit_quit(void);
void sample_edit_reverse(void);
void oscillator_key_function(uint8_t osc_nr);




#endif /* KEYQUERY_H_ */