/*
 * Midi.h
 *
 * Created: 23.07.2016 09:34:54
 *  Author: Rolf Degen
 */ 


#ifndef MIDI_H_
#define MIDI_H_

#include "globals.h"
#include "oscillators.h"
#include "display/displ_funktion.h"
#include "gui.h"
#include "sequencer.h"
#include "miniscope.h"

#define NOTEON		0x90	// Midi NoteOn
#define NOTEOFF		0x80	// Midi NoteOff
#define NOTEPRES	0xA0	// note pressure
#define CONTROLLER	0xB0	// control change
#define AllNoteOff  0x7B	// all notes off
#define PitchWeel   0xE0    // Pitch Weel



struct MidiDispatcher
{
	uint8_t channel;
	uint8_t channel_value;
	uint8_t porta;
	uint8_t porta_value;
	uint8_t legato;
	uint8_t legato_value;
	uint8_t input_flag;
	uint8_t symbol_off_flag;
	uint8_t symbol_time;
	
	uint8_t trigger_flag;
	uint8_t gate_flag;
	
} Mid;


//-------------------------------------------------------------------------
// Funktions
//
uint8_t mididata_avail(void);
void midi_handle(void);
uint8_t read_mididata(void);
void midi_function(uint8_t status);
void midi_Controller(void);
void midi_NoteOn(void);
void midi_NoteOff(void);
void midi_AllNotesOff(void);
void modulation(void);
void pitch_bend(void);
void mod_wheel(void);
void after_touch(void);
void clear_midi_notestack(void);



#endif /* MIDI_H_ */