/*
 * miniscope.h
 *
 * Created: 30.06.2016 20:11:34
 *  Author: rolfd
 */ 


#ifndef MINISCOPE_H_
#define MINISCOPE_H_


void set_scope_mode(void);
void draw_trigger_symbol(uint8_t y_pos);
void trigger_value(void);
void timebase_value(void);
void Scope_sampling(void);
void init_Scope (void);
void Sample_recording(void);
void stop_sampling(void);




struct Miniscope
{
	uint8_t adc_buffer[151];
	uint8_t adc_buffer_old[151];
	uint8_t adc_value;
	uint8_t adc_trigger_level;		// trigger-level = OFF
	uint8_t adc_flag;
	uint8_t adc_wr_pointer;
	uint8_t adc_trigger;
	uint16_t trigger_out_time;
	uint8_t adc_timebase;
	uint8_t timebase_reg;
	uint8_t timebase_level;
	uint8_t scope_mode;
	uint8_t single_flag;			// is 0 when "single sweep" beginns / is 1 when end
	uint8_t scope_gain;
	uint8_t scope_gain_old;
	int8_t scope_offset;
	uint8_t scope_wait_flag;		// flag= 1 scope is wait
	uint8_t scope_wait_time;		// wait time bevor new scope sample
	
} Scope;



#endif /* MINISCOPE_H_ */