/*
 * Oscillators.h
 *
 * Created: 01.07.2016 16:13:49
 *  Author: Rolf Degen
 */ 


#ifndef OSCILLATORS_H_
#define OSCILLATORS_H_



//void Noise_Task (void);
void Osc_Render(uint8_t osc_nr);
void frequency_tune(void);
void OscRender_Sample (uint8_t osc_nr);
void OscRender_USER (uint8_t osc_nr);
void OscRender_SAW_SQUARE(uint8_t osc_nr);
void OscRender_DPWM(uint8_t osc_nr);
void OscRender_TRIANG(uint8_t osc_nr);
void OscRender_CZSAW(uint8_t osc_nr);
void OscRender_CZRESO(uint8_t osc_nr);
void OscRender_CZPULS(uint8_t osc_nr);
void OscRender_PAD(uint8_t osc_nr);
void OscRender_FM(uint8_t osc_nr);
void OscRender_8BIT(uint8_t osc_nr);
void OscRender_CRUSH(uint8_t osc_nr);
void OscRender_CzResoSaw(uint8_t osc_nr);
void OscRender_Noise(uint8_t osc_nr);
void OscRender_OFF(uint8_t osc_nr);

enum // OP_value
{	 OP_SUM	= 0, OP_2CH = 1, OP_SYNC = 2, OP_RING = 3, OP_XOR = 4, OP_BITS = 5, OP_FUZZ = 6};

enum // Mode_value
{	OSC_USER = 0, OSC_SAW = 1, OSC_SQUARE = 2, OSC_DPWM = 3, OSC_TRIANG = 4, OSC_ZSAW = 5,
	OSC_ZSAW_LP = 6, OSC_ZSAW_PK = 7, OSC_ZSAW_HP = 8, OSC_ZPULS_LP = 9, OSC_ZPULS_PK = 10,
	OSC_ZPULS_HP = 11, OSC_ZSYNC = 12, OSC_ZTRI = 13, OSC_SAW_PAD = 14, OSC_QUAD_PWM = 15,
	OSC_FM = 16, OSC_FMFB = 17, OSC_8BIT = 18, OSC_CRUSH = 19, OSC_NOISE = 20, OSC_OFF = 21};

static const uint8_t kNumZonesFullSampleRate = 6;


struct Oscillators
{
	__uint24 phase[2];
	__uint24 phase_increment[2];
	__uint24 loop_endaddr[2];
	uint8_t mix;
	uint16_t data_secondary_phase[2];
	uint8_t number;
	uint8_t wave[2];
	uint8_t wavebank[2];
	uint8_t wave_mode[2];
	uint8_t shape[2];
	uint8_t prm_value[2];
	uint8_t prm[2];
	uint8_t op_value;
	uint8_t rng_value[2];
	uint8_t tune_value;
	uint8_t mix_value;
	uint8_t track_value[2];
	uint8_t noise_value;
	uint8_t sync_function[2];
	uint8_t loop_function[2];
	uint8_t loop_flag[2];
	__uint24 loop_A[2];
	__uint24 loop_B[2];
	uint8_t loop_A_value[2];
	uint8_t loop_B_value[2];
} Osc;

union osc_render_addr
{
	uint8_t addr8[2];
	uint16_t addr16;
} addr;


struct Oscillator1
{	
	uint32_t phase_x;
	//__uint24 phase;
	//__uint24 phase_inc;
	//__uint24 addr;
	uint8_t phase_carry2;
	int32_t phase_stepsize;
	uint8_t wave;
	uint8_t wavebank;
	uint8_t shape;
	uint8_t mode_value;
	uint8_t prm;
	uint8_t prm_value;
	uint8_t rng_value;
	uint8_t subosc_value;
	uint8_t sublev_value;
	uint8_t noisecol_value;
	uint8_t noiselev_value;
	uint8_t osclev_value;
	uint8_t wave_mode;
	uint16_t data_qs_phase[3];
	uint8_t phase_carry;
	uint16_t data_secondary_phase;
	uint8_t data_output_sample;
	uint8_t data_cr_decimate;
	uint8_t data_cr_state;
} Osc1;

struct Oscillator2
{	
	uint32_t phase_x;
	//__uint24 phase;
	//__uint24 phase_inc;
	//__uint24 addr;
	uint8_t phase_carry2;
	int32_t phase_stepsize;
	uint8_t wave;
	uint8_t wavebank;
	uint8_t shape;
	uint8_t mode_value;
	uint8_t prm;
	uint8_t prm_value;
	uint8_t rng_value;
	uint8_t tune_value;
	uint8_t subosc_value;
	uint8_t sublev_value;
	uint8_t noisecol_value;
	uint8_t noiselev_value;
	uint8_t osclev_value;
	uint8_t wave_mode;
	uint16_t data_qs_phase[3];
	uint8_t phase_carry;
	uint16_t data_secondary_phase;
	uint8_t data_output_sample;
	uint8_t data_cr_decimate;
	uint8_t data_cr_state;
	
	
} Osc2;

struct Oscillator12
{
	uint8_t mix_value;
	uint8_t op_value;
	uint8_t noise_value;
	uint8_t syncbuffer[0x90];
	
} Osc12;

struct Noise_generator
{
	uint16_t data_rng_state;
	uint8_t noise_gen;
	uint8_t data_lp_noise_sample;
	uint8_t data_filter_coef;
	uint8_t noise_tick;
	uint8_t sample;
	
} Noise;




#endif /* OSCILLATORS_H_ */